//+------------------------------------------------------------------+
//|                                                         MASO.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrGray
#property indicator_color2  clrGreen
#property indicator_color3  clrRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1.1

//
//
//
//
//

extern int                Length1       = 50;
extern ENUM_MA_METHOD     Method1       =  0;
extern double             Slope1        =  0;
extern int                Slope_Length1 =  1;
extern ENUM_APPLIED_PRICE Price1        =  0;
extern int                Length2       = 10;
extern ENUM_MA_METHOD     Method2       =  1;
extern double             Slope2        =  0;
extern int                Slope_Length2 =  1;
extern ENUM_APPLIED_PRICE Price2        =  0;

double MASO[], MASO_Up[], MASO_Dn[];

int init()
{
   SetIndexBuffer(0,MASO);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,MASO_Up); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,MASO_Dn);  SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorShortName("MA Slope Oscilator");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int i,counted_bars = IndicatorCounted(); 
      if (counted_bars < 0) return(-1); 
      if (counted_bars > 0) counted_bars--;  
         int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (i= limit; i >= 0; i--)    
   {
      double MA_Slope1_Up = 0;
      double MA_Slope1_Dn = 0;
      double MA_Slope2_Up = 0;
      double MA_Slope2_Dn = 0;
             MASO[i]    = EMPTY_VALUE;
             MASO_Up[i] = EMPTY_VALUE;
             MASO_Dn[i] = EMPTY_VALUE;
 
            double MA1=iMA(NULL,0,Length1,0,Method1,Price1,i); double Sl=(MA1-iMA(NULL,0,Length1,0,Method1,Price1,i+Slope_Length1))/Point;
            double MA_Slope1 = MA1;
               if (Sl>Slope1) MA_Slope1_Up=MA1;
               if (Sl<Slope1) MA_Slope1_Dn=MA1;
            double MA2=iMA(NULL,0,Length2,0,Method2,Price2,i);        Sl=(MA2-iMA(NULL,0,Length2,0,Method2,Price2,i+Slope_Length2))/Point;
            double MA_Slope2 = MA2;
               if (Sl>Slope2) MA_Slope2_Up=MA2;
               if (Sl<Slope2) MA_Slope2_Dn=MA2;

            if (MA_Slope1==MA_Slope1_Up && MA_Slope2==MA_Slope2_Up) MASO_Up[i]=1;
            else
               if (MA_Slope1==MA_Slope1_Dn && MA_Slope2==MA_Slope2_Dn)
                        MASO_Dn[i] = 1;
                  else  MASO[i]    = 1;
   }
   return(0);
}